# OpenAGI Contributing Guidelines


OpenAGI projects accept contributions through GitHub pull requests. This document outlines some of the conventions on development workflow, commit message formatting, contact points, and other resources to make it easier to get your contribution accepted.



## By contributing to this project you agree to the [Apache License](https://github.com/openagi/datum/blob/master/LICENSE). 

## Code of Conduct 
   Please read the [Code of Conduct](../CODE_OF_CONDUCT.md)

## Support Channels



The official support channels, for both users and contributors, are:

- GitHub issues: each repository has its own list of issues.

- Slack: join the [openAGI Slack](https://openagi.slack.com) community. Drop in and say, "Hello". A short introduction about yourself and your area of interest may be an ice breaker to welcome and warm up the conversation among the community members.


Before opening a new issue or submitting a new pull request, it's helpful to search the project - it's likely that another user has already reported the issue you're facing, or it's a known issue that we're already aware of.



## How to Contribute



Pull Requests (PRs) are the main and exclusive way to contribute code to openAGI projects. In order for a PR to be accepted it needs to pass a list of requirements:



- The contribution must be correctly explained with natural language and providing a minimum working example that reproduces it.

- All PRs must be written idiomaticly. They should in general include tests, and those shall pass. 

- In any case, all the PRs have to pass the personal evaluation of at least one of the maintainers of the project.



Format of the commit message:

Every commit message should describe what was changed, under which context and, if applicable, the GitHub issue it relates to.
